/*
 * Copyright 2001-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.unitesk.atp.bnf.actions.toAntlr;

import java.util.Map;

public class AntlrUtils
{
    public static String toAntlrId( String s, Map token_names )
    {
        String res = (String)token_names.get( s );
        return res != null ? res : toAntlrId( s );
    }

    public static String toAntlrId( String s )
    {
        s = s.replaceAll( "([a-z0-9])([A-Z])", "$1_$2" );
        s = s.replaceAll( "([A-Z])([A-Z][a-z])", "$1_$2" );
        s = s.replace( '-', '_' );
        s = s.toUpperCase();
        return s;
    }
}
