/*
 * Copyright 2001-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
//==============================================================================

package com.unitesk.atp.bnf.actions.toTreeDL;

//==============================================================================

import java.util.Vector;
import java.util.Hashtable;

import com.unitesk.atp.bnf.BNFModel.*;

//==============================================================================

public class OneLexemeFactor extends EnumFlagFactor
{
    private String lexeme;
    public OneLexemeFactor( String an, int k, Vector lxms )
    {
        super(an,k,lxms);
        lexeme = (String)lxms.get(0);
    }

    public String getLexeme(){ return lexeme; }
    public boolean isOpt(){ return kind == Expression_Factor.OPTIONAL; }

    public String getType( Hashtable ef_node_list )
    {
        switch( kind )
        {
        case Expression_Factor.OPTIONAL: return "attribute bool";
        default: return "attribute int";
        }
    }

    public String getName( Hashtable ef_node_list )
    {
        return (getTable().keySet().toArray()[0] + "").toLowerCase() + ((isOpt())? "Opt": "Size");
    }

    public String kindToString(){ return ""; };
}
