/*
 * Copyright 2001-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
//==============================================================================

package com.unitesk.atp.bnf.actions.toTreeDL;

//==============================================================================

import java.util.Hashtable;

import com.unitesk.atp.bnf.BNFModel.*;

//==============================================================================

public class SeparatedListFactor extends AlterExpression_Factor
{
    private Factor elem;
    private Lexeme_Factor separ;

    public SeparatedListFactor( int k, Factor el, Lexeme_Factor sep )
    {
        kind = k;
        elem = el;
        separ = sep;
    }

    public String getSepar()
    {
        return separ.getLexeme();
    }

    public String getName( Hashtable ef_node_list )
    {
        String postfix = ((kind != Expression_Factor.OPTIONAL) ? "List" : "Opt");
        return (elem instanceof Name_Factor) ? 
            NamesUtils.getNameFactorChildName( (Name_Factor)elem ) + postfix
            : NamesUtils.getLexemeFactorChildName( (Lexeme_Factor)elem ) + postfix
            ;
    }

    public String getType( Hashtable ef_node_list )
    {
        return (elem instanceof Name_Factor) ? 
            "child " + NamesUtils.getName( ((Name_Factor)elem).getName().getValue() )
            : "attribute " + NamesUtils.getLexemeType( (Lexeme_Factor)elem )
            ;
    }

}
