/*
 * Copyright 2001-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.unitesk.atp.bnf.auxil;


import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.nio.channels.FileChannel;

import java.util.Map;
import java.util.HashMap;
import java.util.Properties;
import java.util.Enumeration;

import com.unitesk.atp.tool.Plugin;


public class FileUtils
{
    public static  Map loadMap( Plugin plugin, String property_for_file_name, boolean map_inverse )
    {
        Map res = new HashMap();
        String token_names_file = plugin.getProperty( property_for_file_name );
        if( token_names_file != null )
        {
            try
            {
                Properties p = new Properties();
                p.load( new FileInputStream( token_names_file ) );
                Enumeration e = p.propertyNames();
                while( e.hasMoreElements() )
                {
                    String name = (String)e.nextElement();
                    String token = p.getProperty( name );
                    if( map_inverse )
                    {
                        res.put( token, name );
                    } else {
                        res.put( name, token );
                    }
                }
            } catch( java.io.FileNotFoundException e ) {
            } catch( java.io.IOException e ) {
            }
        }
        return res;
    }

    public static void copyFile( File srcFile, File dstFile ) throws java.io.IOException
    {
        FileChannel srcChannel = new FileInputStream( srcFile ).getChannel();
        FileChannel dstChannel = new FileOutputStream( dstFile ).getChannel();
        dstChannel.transferFrom( srcChannel, 0, srcChannel.size() );
        srcChannel.close();
        dstChannel.close();
    }

}
