/*
 * Copyright 2001-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.unitesk.atp.bnf.actions.toAntlr;


import com.unitesk.atp.tree.generation.TextGeneratorVisitor;
import com.unitesk.atp.bnf.BNFModel.*;


public class AntlrVarInitPrinterVisitor
    extends TextGeneratorVisitor
    implements BNF_Visitor
{
    public void visitGrammar( Grammar node )
    {}

    public void visitRule( Rule node )
    {
        if( node.hasAttribute( "returnNode" ) )
        {
            list( "i", 0, node.sizeAttribute( "antlrVarList" ), "${antlrVarList[i]}", "" );
        } else if( node.hasAttribute( "returnList" ) ) {
            String type
                = "attr".equals( node.getAttribute( "listElementKind" ) )
                ? "${antlrElemType}"
                : "${.model_class}.${antlrElemType}"
                ;

            txt( "${.result_var} = ${.list_factory}.<" + type + ">create();" );
            nl();
        }
    }

    public void visitExpression( Expression node )
    {}

    public void visitTerm( Term node )
    {}

    public void visitFactor( Factor node )
    {
        if( AntlrVarDeclsSetVisitor.isList( node ) )
        {
            txt( "${antlrVarName} = ${.list_factory}.<${antlrVarType}>create();" );
            nl();
        }
    }

    public void visitName_Factor( Name_Factor node )
    {
        visitFactor( node );
    }

    public void visitLexeme_Factor( Lexeme_Factor node )
    {
        visitFactor( node );
    }

    public void visitExpression_Factor( Expression_Factor node )
    {
        visitFactor( node );
    }

    public void visitID( ID node )
    {
        txt( "${value}" );
    }
}
