/*
 * Copyright 2001-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.unitesk.atp.bnf.actions.toAntlr;


import com.unitesk.atp.bnf.BNFModel.*;
import com.unitesk.atp.tree.generation.TextGeneratorVisitor;


public class TreedlEnumsPrinterVisitor
    extends TextGeneratorVisitor
    implements BNF_Visitor
{
    public void visitGrammar( Grammar node )
    {
        list( "i", 0, node.sizeOptRuleList(), "${optRuleList[i]}", "" );
    }

    public void visitRule( Rule node )
    {
        txt( "${expression}" );
    }

    public void visitExpression( Expression node )
    {
        list( "i", 0, node.sizeTermList(), "${termList[i]}", "" );
    }

    public void visitTerm( Term node )
    {
        list( "i", 0, node.sizeFactorList(), "${factorList[i]}", "" );
    }

    public void visitFactor( Factor node )
    {}

    public void visitName_Factor( Name_Factor node )
    {}

    public void visitLexeme_Factor( Lexeme_Factor node )
    {}

    public void visitExpression_Factor( Expression_Factor node )
    {
        if( node.hasAttribute( "treedlEnum" ) )
        {
            txt( "enum ${treedlAttrType} { " );
            list( "i", 0, node.sizeAttribute( "treedlEnumElems" ), "${treedlEnumElems[i]}", ", " );
            txt( " }" ); nl();
        } else {
            txt( "${expression}" );
        }
    }

    public void visitID( ID node )
    {
        txt( "${value}" );
    }
}
