/*
 * Copyright 2001-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
//==============================================================================

package com.unitesk.atp.bnf.actions.toTreeDL;

//==============================================================================

import java.util.Hashtable;

import com.unitesk.atp.bnf.BNFModel.*;

//==============================================================================

public class ChildFactor extends AlterExpression_Factor
{
    private Factor factor;

    public ChildFactor( int k, Factor f )
    {
        if( f instanceof Expression_Factor )
        {
            throw new IllegalStateException( "Unexpected Expression_Factor in ChildFactor" );
        }
        kind = k;
        factor = f;
    }

    public Factor getFactor()
    {
        return factor;
    }

    public String getName( Hashtable ef_node_list )
    {
        String nm = null;
        String postfix = ( kind == Expression_Factor.ONE_LIST || kind == Expression_Factor.ZERO_LIST ) ? "List" : "";
        if( factor instanceof Lexeme_Factor )
        {
            String val = ((Lexeme_Factor)factor).getLexeme();
            if( val.substring(0,1).equals("<") )
            {
                nm = NamesUtils.getLexemeFactorChildName( (Lexeme_Factor)factor );
            } else
            {
                throw new IllegalStateException( "BUG in TDLGenerator: lexeme text in ChildFactor" );
            }
        } else if( factor instanceof Name_Factor)
        {
            nm =  NamesUtils.getNameFactorChildName( (Name_Factor)factor );
        }
        return nm + postfix;
    }

    public String getType( Hashtable ef_node_list )
    {
        String type = "";
        if( factor instanceof Lexeme_Factor )
        {
            type = "attribute " + NamesUtils.getLexemeType( (Lexeme_Factor)factor );
        }
        else type = "child " + NamesUtils.getName( ((Name_Factor)factor).getName().getValue() );
        return type;
    }

    private Lexeme_Factor separ = null;

    public void setSepar( Lexeme_Factor s )
    {
        separ = s;
    }

    public String getSepar()
    {
        return ( separ != null ) ? separ.getLexeme() : "\"\"";
    }
}
