/*
 * Copyright 2001-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
//==============================================================================

package com.unitesk.atp.bnf.actions.toTreeDL;

//==============================================================================

import java.util.Hashtable;

//==============================================================================

public class ExpressionEF extends AlterExpression_Factor
{
    public ExpressionEF( int k )
    {
        kind = k;
    }

    public int getKind()
    {
        return kind;
    }

    public String getName( Hashtable ef_node_list )
    {
        NodeDescriptor nd = (NodeDescriptor)ef_node_list.get(this);
        if( nd == null )
            throw new IllegalStateException( "BUG in TDLGenerator: null NodeDescriptor" );
        return NamesUtils.beginToLower( nd.getName() );
    }

    public String getType( Hashtable ef_node_list )
    {
        NodeDescriptor nd = (NodeDescriptor)ef_node_list.get(this);
        if( nd == null )
            throw new IllegalStateException( "BUG in TDLGenerator: null NodeDescriptor" );
        return "child " + nd.getName();
    }
}

