/*
 * Copyright 2001-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.unitesk.atp.bnf.messages;

import com.unitesk.atp.messages.Message;

public class ExceptionMessage implements Message
{
    public ExceptionMessage( Exception p_exception, String p_context )
    {
        exception = p_exception;
        context = p_context;
    }

    public String getContext() { return context; }
    public Exception getException() { return exception; }

    private final String context;
    private final Exception exception;
}
