/*
 * Copyright 2001-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.unitesk.atp.bnf.actions.testgen.auxil;

//==============================================================================

import java.io.PrintWriter;
import java.util.Hashtable;
import java.util.Vector;

import com.unitesk.atp.bnf.BNFModel.Rule;


//==============================================================================

public class ChainBuilder
{
    /**
     *     start  target
     *
     */

    public static Vector/*Rule*/ getChain( Rule start, Rule target )
    {
        Hashtable/*Rule,Rule*/ rule_to_rule = new Hashtable/*Rule,Rule*/();
        Vector/*Rule*/ queue = new Vector/*Rule*/();

        rule_to_rule.put( target, target );
        queue.addElement( target );

        for( int i = 0; i < queue.size(); i++ )
        {
            Rule t = (Rule)queue.elementAt( i );

            if( t == start )
            {
                Vector/*Rule*/ res = new Vector/*Rule*/();

                // make chain
                res.addElement( t );

                while( t != target )
                {
                    t = (Rule)rule_to_rule.get( t );
                    res.addElement( t );
                }

                return res;
            }

            for( int j = 0; j < t.sizeOptReferenceList(); j++ )
            {
                Rule r = t.getOptReferenceList( j );
                if( !rule_to_rule.containsKey( r ) )
                {
                    rule_to_rule.put( r, t );
                    queue.addElement( r );
                }
            }
        }
        return null;
    }

    public static void printChain( Vector/*Rule*/ chain, PrintWriter out )
    {
        out.println( "  <list>" );
        for( int i = 0; i < chain.size(); i++ )
        {
            Rule r = (Rule)chain.elementAt( i );
            out.println( "    <item>" + r.getName().getValue() + "</item>" );
        }
        out.println( "  </list>" );
    }
}
