/*
 * Copyright 2001-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
//==============================================================================

package com.unitesk.atp.bnf.actions.testgen.auxil;

//==============================================================================

import java.util.HashSet;
import java.util.Iterator;
import java.util.Vector;

//==============================================================================

/**
 *  .
 */
public class SentenceList
{
    /**
     *  .
     */
    public SentenceList() { sentence_list = new Vector/*Sentence*/(); }

    /**
     *    .
     */
    public SentenceList( Sentence s )
    {
        this();
        append( s );
    }

    public SentenceList( HashSet set )
    {
        this();
        Iterator it = set.iterator();
        while( it.hasNext() )
        {
            Object o = it.next();
            append( (Sentence)o );
        } 
    }

    /**
     *    .
     */
    public SentenceList makeClone()
    {
        return new SentenceList( (Vector/*Sentence*/)sentence_list.clone() );
    }

    /**
     *     .
     */
    public int size() { return sentence_list.size(); }

    /**
     *     .
     */
    public Sentence get( int i ) { return (Sentence)sentence_list.elementAt( i ); }

    /**
     *    .
     */
    public void append( Sentence sentence ) 
    { 
        sentence_list.addElement( sentence );
    }

    /**
     *   .
     */
    public void append( SentenceList sl )
    {
        for( int s = 0; s < sl.size(); s++ )
        {
            append( sl.get( s ) );
        }
    }

    /**
     *   ,    
     *   ,   -   tail.
     */
    public void combine( SentenceList tail )
    {
        if( size() == 0 )
        {
            return;
        }

        if( tail == null || tail.size() == 0 )
        {
            sentence_list.removeAllElements();
            return;
        }

        Vector/*Sentence*/ res = new Vector/*Sentence*/();
        for( int i = 0; i < sentence_list.size(); i++ )
        {
            for( int j = 0; j < tail.size(); j++ )
            {
                Sentence s = get( i ).makeClone();
                s.append( tail.get( j ) );
                res.addElement( s );
            }
        }
        sentence_list = res;
    }

    public void combine( Sentence tail )
    {
        if( size() == 0 )
        {
            return;
        }

        if( tail == null )
        {
            sentence_list.removeAllElements();
            return;
        }

        Vector/*Sentence*/ res = new Vector/*Sentence*/();
        for( int i = 0; i < sentence_list.size(); i++ )
        {
            Sentence s = get( i ).makeClone();
            s.append( tail );
            res.addElement( s );
        }
        sentence_list = res;
    }

    public void filterTerminals()
    {
        for( int i = 0; i < size(); i++ )
        {
            get(i).filterTerminals();
        }
    }

    public HashSet getSetView()
    {
        HashSet res = new HashSet();
        for( int i = 0; i < size(); i++ )
        {
            res.add(get(i));
        }
        return res;
    }

    private SentenceList( Vector/*Sentence*/ sl ) { sentence_list = sl; }

    private Vector/*Sentence*/ sentence_list;
}
